Subject: bug#44310: 27.1; eshell over tramp-mode cannot locate /bin/ executables on the remote machine

From: Michael Albinus <[email-masked]>
Date: Sat, 14 Nov 2020 10:45:20 +0100

Novak Boškov <[email-masked]> writes:

Hi Novak,

> Steps to reproduce:
> 1. Use regular C-x C-f /ssh:remote:/path/on/remote. The remote machine is a
> GNU Linux machine too.
>
> 2. Then open eshell using M-x eshell on the remote machine.
>
> 3. Type `top` in the eshell prompt. You see the following error in a *top*
> buffer:
>
> ..: 1: exec: /ssh:remote:/bin/top: not found
>
> Process /ssh:remote:/bin/top exited abnormally with code 127

Thanks for the report, I can reproduce it locally.

> Expected behavior:
> Since /bin/top is present on the remote (which can be verified if you do
> the same in M-x shell), I'd expect top to work there via eshell.
>
> I've verified that top in eshell does work if the eshell is run on the
> local machine (no ssh and tramp-mode).

"top" is a visual eshell command, as declared in `eshell-visual-commands'.
These commands need a terminal for proper run, so they are using term.el.
Unfortunately, this package does not support remote processes (yet), and
therefore eshell visual commands do not run remotely.

See also bug#27612 and bug#36748. I'm going to move this bug report as
wishlist, and I'll merge it with the other two bugs.

Best regards, Michael.